
#include <stdio.h>
#include <math.h>
#include "pref.h"
/* driver1.f -- translated by f2c (version of 23 April 1993  18:34:30).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "f2c.h"

#define BFGSPRINT ((long int)-1)
#define BFGSFACTR (10000000)
#define BFGSPGTOL (0.00001)
#define BFGSNMAX ((long int)1500)
#define BFGSMMAX ((long int)17)
#define BFGSM ((long int)10)
#define	EVALLIMIT (100)

/*                             DRIVER 1 */
/*     -------------------------------------------------------------- */
/*                SIMPLE DRIVER FOR L-BFGS-B (version 2.1) */
/*     -------------------------------------------------------------- */

/*        L-BFGS-B is a code for solving large nonlinear optimization */
/*             problems with simple bounds on the variables. */

/*        The code can also be used for unconstrained problems and is */
/*        as efficient for these problems as the earlier limited memory */
/*                          code L-BFGS. */

/*        This is the simplest driver in the package. It uses all the */
/*                    default settings of the code. */


/*     References: */

/*        [1] R. H. Byrd, P. Lu, J. Nocedal and C. Zhu, ``A limited */
/*        memory algorithm for bound constrained optimization'', */
/*        SIAM J. Scientific Computing 16 (1995), no. 5, pp. 1190--1208. */

/*        [2] C. Zhu, R.H. Byrd, P. Lu, J. Nocedal, ``L-BFGS-B: FORTRAN */
/*        Subroutines for Large Scale Bound Constrained Optimization'' */
/*        Tech. Report, NAM-11, EECS Department, Northwestern University, */
/*        1994. */


/*          (Postscript files of these papers are available via anonymous */
/*           ftp to eecs.nwu.edu in the directory pub/lbfgs/lbfgs_bcm.) */

/*                              *  *  * */

/*        NEOS, November 1994. (Latest revision June 1996.) */
/*        Optimization Technology Center. */
/*        Argonne National Laboratory and Northwestern University. */
/*        Written by */
/*                           Ciyou Zhu */
/*        in collaboration with R.H. Byrd, P. Lu-Chen and J. Nocedal. */

/*     NOTE: The user should adapt the subroutine 'timer' if 'etime' is */
/*           not available on the system.  An example for system */
/*           AIX Version 3.2 is available at the end of this driver. */

/*     ************** */
/* Subroutine */
    extern int setulb_(integer *, integer *, doublereal *, 
	    doublereal *, doublereal *, integer *, doublereal *, doublereal *,
	     doublereal *, doublereal *, doublereal *, integer *, char *, 
	    integer *, char *, logical *, integer *, doublereal *, ftnlen, 
	    ftnlen);
	    
int bfgs_minfunc ( int (* Evaluate_FuncGrad)(void *, bfgs_FuncGrad *),
				  void * setting, bfgs_FuncGrad * bfgssetting ) 
{
    /* Format strings */
    static char fmt_16[] = "(/,5x,\002L_BFGS_B:\002,/)";
	//static char fmt_16[] = "" ;

    /* System generated locals */
    integer i__1;
    //doublereal d__1, d__2;

    /* Builtin functions */
    integer s_wsfe(cilist *), e_wsfe();
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    integer s_cmp(char *, char *, ftnlen, ftnlen);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    char task[60];
    doublereal f, g[BFGSNMAX] ;
    integer i;
    doublereal l[BFGSNMAX];
    integer m, n;
    doublereal u[BFGSNMAX], x[BFGSNMAX], factr;
    char csave[60];
    doublereal dsave[29];
    integer isave[44];
    logical lsave[4];
    doublereal pgtol, wa[2*BFGSMMAX*BFGSNMAX+4*BFGSNMAX+12*BFGSMMAX*BFGSMMAX+12*BFGSMMAX];

    integer iprint, nbd[BFGSNMAX], iwa[BFGSNMAX*3];

    /* Fortran I/O blocks */
    static cilist io___11 = { 0, 6, 0, fmt_16, 0 };

	if ( NULL == setting || NULL == bfgssetting )
		return 1 ;

/*     This simple driver demonstrates how to call the L-BFGS-B code to */
/*       solve a sample problem (the extended Rosenbrock function */
/*       subject to bounds on the variables). The dimension n of this */
/*       problem is variable. */
/*        nmax is the dimension of the largest problem to be solved. */
/*        mmax is the maximum number of limited memory corrections. */
/*     Declare the variables needed by the code. */
/*       A description of all these variables is given at the end of */
/*       the driver. */
/*     Declare a few additional variables for this sample problem. */
/*     We wish to have output at every iteration. */

	// copy bfgs settings


    iprint = BFGSPRINT ; // no print
/*     We specify the tolerances in the stopping criteria. */
    factr = BFGSFACTR ; //1e7;
    pgtol = BFGSPGTOL ; //1e-5;
/*     We specify the dimension n of the sample problem and the number */
/*        m of limited memory corrections stored.  (n and m should not */
/*        exceed the limits nmax and mmax respectively.) */
    m = BFGSM ;
    n = bfgssetting->var_number ;
/*     We now provide nbd which defines the bounds on the variables: */
/*                    l   specifies the lower bounds, */
/*                    u   specifies the upper bounds. */
/*     First set bounds on the odd-numbered variables. */

	if (n>BFGSNMAX||m>BFGSMMAX)
		return 1 ;
    i__1 = n;
	//nbd[0] = 0 ; ;
	//l[0] = bfgssetting->infVc ;
	//u[0] = bfgssetting->supVc ;	
	//nbd[1] = 0 ; ;
	//l[1] = log(bfgssetting->infEps) ;
	//u[1] = log(bfgssetting->supEps) ;
    for (i = 0 ; i < n; i++) {
	nbd[i] = 0 ; ;
	//l[i] = log(bfgssetting->infArd) ;
	//u[i] = log(bfgssetting->supArd) ;
/* L10: */
    }

/*     We now define the starting point. */
    i__1 = n;
    for (i = 0; i < i__1; ++i) {
	x[i] = bfgssetting->x[i] ;
/* L14: */
    }
    s_wsfe(&io___11);
    e_wsfe();
/*     We start the iteration by initializing task. */

    s_copy(task, "START", 60L, 5L);
/*        ------- the beginning of the loop ---------- */
L111:
/*     This is the call to the L-BFGS-B code. */
    setulb_(&n, &m, x, l, u, nbd, &f, g, &factr, &pgtol, wa, iwa, task, &
	    iprint, csave, lsave, isave, dsave, 60L, 60L);
    if (s_cmp(task, "FG", 2L, 2L) == 0) {
/*        the minimization routine has returned to request the */
/*        function f and gradient g values at the current x. */
/*        Compute function value f for the sample problem. */
/* Computing 2nd power */

	// calculate fx and gx at the POINT x 

	//if (fmod (isave[24],2.0) != 0) //chuwei iback <= 10 used 
 	//	bfgssetting->X->maskednorm = -1 ; // clean ALPHA matrix

    i__1 = n;
	/*if (x[0] > u[0])
		x[0] = u[0] ;
	else if (x[0] < l[0])
		x[0] = l[0] ;
	if (x[1] > u[1])
		x[1] = u[1] ;
	else if (x[1] < l[1])
		x[1] = l[1] ;
	for (i = bfgssetting->adjnum ; i < n; i++) 
	{
		if (x[i] > u[i])
			x[i] = u[i] ;
		else if (x[i] < l[i])
			x[i] = l[i] ;
	}*/
	for (i = 0; i < i__1; i++) 
	{
	   bfgssetting->x[i] = x[i] ;
	}
	if ( 1 == (*Evaluate_FuncGrad)(setting, bfgssetting) ) 
	{
		printf( "\r\nFATAL ERROR : Evaluate_FuncGrad failed in BFGS.\r\n" ) ;
		f = dsave[1] + fabs(dsave[1]) ;
		i__1 = n;
		for (i = 0 ; i < i__1; i++) {
			g[i] = - bfgssetting->gx[i] ;
		}
		//return FALSE ;
	}
	else 
	{
		f = bfgssetting->fx ;
		i__1 = n;
		for (i = 0 ; i < i__1; i++) {
			g[i] = bfgssetting->gx[i];
			x[i] = bfgssetting->x[i];
		}
	}
	
/*          go back to the minimization routine. */
	goto L111;
    }

    if (s_cmp(task, "NEW_X", 5L, 5L) == 0) {
		bfgssetting->iternum = isave[29] ;
		printf("%2d: obj f = %.2f	|proj g| = %.2f  	with %d evaluations\n",
			(int)isave[29], f, dsave[12], (int)isave[33] ) ;
	if (isave[33] >= EVALLIMIT && EVALLIMIT > 1 ) {
	s_copy(task, "STOP: TOTAL NO. of f AND g EVALUATIONS EXCEEDS LIMIT", 60L, 52L);
	printf ("Stop: the number of evaluations exceeds limit.\n") ;
	}
	if (dsave[12] <= ( fabs(f) + 1.) * 1e-5) {
	    s_copy(task, "STOP: THE PROJECTED GRADIENT IS SUFFICIENTLY SMALL", 60L, 50L);
		printf("Stop: the projected gradient is sufficiently small.\n") ;
	}
	
	if ( fabs(dsave[1]-f) < fabs(dsave[1]) * 1e-5  && isave[29] > 2 ) 
		//&& bfgssetting->smo_quickmode == TRUE )
	{
		s_copy(task, "STOP: THE DESCENT ON FUNCTION IS SUFFICIENTLY SMALL", 60L, 50L);
		printf("Stop: the descent on function is sufficiently small.\n") ;
	}

	goto L111;
    }
/*        the minimization routine has returned with a new iterate, */
/*         and we have opted to continue the iteration. */
/*           ---------- the end of the loop ------------- */
/*     If task is neither FG nor NEW_X we terminate execution. */
    //s_stop("", 0L);
	// copy x into funcgrad 
	i__1 = n;
	for (i = 0; i < i__1; i++) {
	   bfgssetting->x[i] = x[i] ;
	}
	bfgssetting->iternum = isave[29] ;

	return 0 ;
}
#ifdef __cplusplus
	}
#endif

